# Benchmarks

This benchmark was automatically generated by test/benchmark.jl. In order to run this file you have to install BenchmarkTools.jl first.


Benchmarked on: Intel(R) Core(TM) i7-8750H CPU @ 2.20GHz

## Building
### System 1

```julia 
modes = [Mode(2., 2.)]
mols = [
    Molecule(modes, 5, [0., 200.]),
    Molecule(modes, 5, [0., 300.])
    ]

agg1 = Aggregate(mols)
agg1.coupling[2, 3] = 100
agg1.coupling[3, 2] = 100
```
Basis size: 50


Franck Condon factors

  0.228329 seconds (392.86 k allocations: 21.240 MiB)

Hamiltonian

  0.227289 seconds (273.56 k allocations: 14.209 MiB)
### System 2

```julia 
modes = [Mode(2., 2.)]
mols = [
    Molecule(modes, 5, [0., 200.]),
    Molecule(modes, 5, [0., 300.]),
    Molecule(modes, 5, [0., 300.])
    ]

agg2 = Aggregate(mols)
agg2.coupling[2, 3] = 100
agg2.coupling[3, 2] = 100
agg2.coupling[3, 4] = 100
agg2.coupling[4, 3] = 100
```
Basis size: 375


Franck Condon factors

  0.076725 seconds (281.25 k allocations: 5.365 MiB)

Hamiltonian

  0.045935 seconds (281.63 k allocations: 5.370 MiB)
### System 3

```julia 
modes = [Mode(2., 2.), Mode(3., 2.)] 
mols = [ 
    Molecule(modes, 5, [0., 200.]), 
    Molecule(modes, 5, [0., 300.]) 
    ] 
    
agg3 = Aggregate(mols) 
agg3.coupling[2, 3] = 100 
agg3.coupling[3, 2] = 100
```
Basis size: 1250


Franck Condon factors

  0.415290 seconds (1.56 M allocations: 35.763 MiB, 1.98% gc time)

Hamiltonian

  0.282410 seconds (2.35 M allocations: 47.703 MiB, 2.61% gc time)
## Evolution

 `tspan = [0.0:0.02:1.0;]`

### System 1


evolutionExact(rho0, Ham1, tspan)

  9.216 ms (723 allocations: 6.70 MiB)

evolutionApproximate(rho0, Ham1, tspan)

  2.971 ms (676 allocations: 3.93 MiB)
### System 2


evolutionExact(rho0, Ham2, tspan)

  501.302 ms (723 allocations: 346.65 MiB)

evolutionApproximate(rho0, Ham2, tspan)

  219.483 ms (678 allocations: 221.06 MiB)
### System 3


evolutionExact(rho0, Ham3, tspan)

  12.391 s (745 allocations: 3.73 GiB)

evolutionApproximate(rho0, Ham3, tspan)

  7.535 s (680 allocations: 2.42 GiB)
## Schrödinger

 `tspan = [0.0:0.02:1.0;]`

### System 1


schroedinger(psi0, Ham1, tspan; reltol=1e-10, abstol=1e-10, alg=OrdinaryDiffEq.Tsit5())

  47.283 ms (16111 allocations: 815.69 KiB)

schroedinger(psi0, Ham1, tspan; reltol=1e-12, abstol=1e-12, alg=OrdinaryDiffEq.Vern7())

  47.987 ms (16970 allocations: 1.12 MiB)
### System 2


schroedinger(psi0, Ham2, tspan; reltol=1e-10, abstol=1e-10, alg=OrdinaryDiffEq.Tsit5())

  2.453 s (17731 allocations: 1.22 MiB)

schroedinger(psi0, Ham2, tspan; reltol=1e-12, abstol=1e-12, alg=OrdinaryDiffEq.Vern7()

  2.668 s (19600 allocations: 3.35 MiB)
### System 3


schroedinger(psi0, Ham3, tspan; reltol=1e-10, abstol=1e-10, alg=OrdinaryDiffEq.Tsit5())

  20.189 s (11477 allocations: 1.85 MiB)

schroedinger(psi0, Ham2, tspan; reltol=1e-12, abstol=1e-12, alg=OrdinaryDiffEq.Vern7()

  23.155 s (13772 allocations: 8.67 MiB)
## lLiouville-von Neumann

 `tspan = [0.0:0.02:1.0;]`

### System 1


liouvilleVonNeumann(rho0, Ham1, tspan; reltol=1e-10, abstol=1e-10, alg=OrdinaryDiffEq.Tsit5())

  2.401 s (182742 allocations: 12.15 MiB)

liouvilleVonNeumann(rho0, Ham1, tspan; reltol=1e-12, abstol=1e-12, alg=OrdinaryDiffEq.Vern7())

  2.816 s (215466 allocations: 27.29 MiB)
### System 2


liouvilleVonNeumann(rho0, Ham2, tspan; reltol=1e-10, abstol=1e-10, alg=OrdinaryDiffEq.Tsit5())

  1509.158 s (143430 allocations: 153.42 MiB)

liouvilleVonNeumann(rho0, Ham2, tspan; reltol=1e-12, abstol=1e-12, alg=OrdinaryDiffEq.Vern7()

  2035.052 s (193906 allocations: 911.38 MiB)
